function Update()
    frame = frame + 1
    Keyboard()
    Mouse()
    UpdateLine()
    if not paused then
        BuildShips()
        UpdateFleets()
        ComputerAI()
    end
    UpdateSend()
end

function Keyboard() 
    function love.keypressed(key, scancode, isrepeat)
        if key == "escape" then love.event.quit() end
        if key == "n" then Initiate() end
    end
end

function Mouse()
    mx, my = love.mouse.getPosition()
    function love.mousepressed(x, y, b) 
        mbpx = x
        mbpy = y 
        mbpb = b
    end
    function love.mousereleased(x, y, b)
        mbrx = x
        mbry = y 
        mbrb = b
        UpdatePaused()
    end
end

function UpdateLine()
    if not mouseOver then return end
    local i = mxyIsStar()
    if i then
        ldx = star[i].x
        ldy = star[i].y 
        ld = i
    else
        ldx = mx
        ldy = my
    end
    if not drawLine then
        if mbrb then
            mbrb = false
            if i and star[i].owner == 1 then
                lox = star[i].x
                loy = star[i].y
                lo = i
                drawLine = true
            end
        end
    else
        if mbrb then
            mbrb = false
             drawLine = false
             if i and star[lo].owner == 1 then
                mouseOver = false
                local yes = TargetInRange(lo, ld)
                if yes then
                     sendFleet = true 
                else
                    mouseOver = true
                    sendFleet = false
                end
                ships = 0
             end
        end
    end
end

function UpdateFleets() 
    local i = 1
    while i < fleetTop do
        local x1 = fleet[i].x1
        local y1 = fleet[i].y1
        local x2 = fleet[i].x2
        local y2 = fleet[i].y2
        local dx = fleet[i].dx
        local dy = fleet[i].dy
        local dst = fleet[i].dst
        x1 = x1 + dx
        y1 = y1 + dy
        if math.abs(x2 - x1) < 1 and math.abs(y2 - y1) < 1 then
            if fleet[i].owner == star[dst].owner then
                star[dst].ships = star[dst].ships + fleet[i].ships
            else
                ResolveBattle(fleet[i].owner, fleet[i].dst, fleet[i].ships)
            end
            fleetTop = fleetTop - 1
            fleet[i] = fleet[fleetTop]
            fleet[fleetTop] = {}
        else
            fleet[i].x1 = x1
            fleet[i].y1 = y1
        end
        i = i + 1    
    end
end

function ResolveBattle(owner, dst, ships)
    local enemy = star[dst].ships
    local s = ships
    local e = enemy
    while ships > 0 and enemy > 0 do
      ships = ships - math.floor((e / 9) + 10) --defenders advantage
      enemy = enemy - math.floor((s / 10) + 10) 
      s = ships
      e = enemy 
    end
    if ships <= 0 then
        star[dst].ships = enemy + 10
    else
        star[dst].owner = owner
        star[dst].ships = ships
    end
end

function UpdateSend()
  if not sendFleet then return end
  if mbrb then
      if mbrx >= gx + 416 and mbrx <= gx + 476 and mbry >= gy + 4 and mbry <= gy + 64 then
          sendFleet = false
          mouseOver = true
          ships = 0
      end
      if mbrx >= gx + 12 and mbrx <= gx + 472 and mbry >= gy + 218 and mbry <= gy + 302 then
          local i = math.floor((mbrx - gx - 12) / 46)
          ships = math.min(star[lo].ships, ships * 10 + i)
      end 
      if mbrx >= gx + 376 and mbrx <= gx + 476 and mbry >= gy + 500 and mbry <= gy + 536 then
          SendFleet(lo, ld, ships)
          sendFleet = false
          mouseOver = true
          ships = 0
      end
   end
   mbrb = false
end

function SendFleet(org, dst, ships)
    local i = fleetTop
    fleetTop = fleetTop + 1
    local x1 = star[org].x
    local y1 = star[org].y
    local x2 = star[dst].x
    local y2 = star[dst].y
    local dist = math.sqrt((x2 - x1) ^ 2 + (y2 - y1) ^ 2)
    fleet[i].dx = (x2 - x1) / dist
    fleet[i].dy = (y2 - y1) / dist
    fleet[i].owner = star[org].owner
    fleet[i].dst = dst
    fleet[i].x1 = x1
    fleet[i].y1 = y1
    fleet[i].x2 = x2
    fleet[i].y2 = y2
    fleet[i].ships = ships
    star[org].ships = star[org].ships - ships
end

function BuildShips()
    for i = 1, 200 do
        local r = love.math.random(1000)
        if star[i].owner == 13 then
            if r / 2 < star[i].size then
                star[i].ships = star[i].ships + 1
            end
        else
            if r / 8 < star[i].size then
                star[i].ships = star[i].ships + 1
            end
        end   
    end
end

function UpdatePaused()
    if not drawLine and not mxyIsStar() and mbrb == 2 then
        if paused == true then
            paused = false
        else
            paused = true
        end
    end
end