function Distance(i, j)
    return math.sqrt((star[i].x - star[j].x) ^ 2 + (star[i].y - star[j].y) ^ 2)
end

function DetermineRange()
    local min = 0
    for i = 1, 200 do
        local max = 1000
        for j = 1, 200 do
            if j ~= i then
                local d = Distance(i, j)
                if d < max then
                    max = d
                end
            end
        end
        if max > min then
            min = max
        end
    end
    return min + 10
end

function mxyIsStar()
    for i = 1, 200 do
        if math.abs(mx - star[i].x) < 15 and math.abs(my - star[i].y) < 15 then
            return i 
        end
    end
    return false
end

function TargetInRange(org, dst) 
    if star[dst].owner == star[org].owner then return true end --slipstream projectors at each end lol
    for i = 1, 200 do
        if star[i].owner == star[org].owner then
            local dist = Distance(i, dst)
            if dist <= range then return true end
        end
    end
    return false
end

function Enroute(owner, dst)
    for i = 1, fleetTop - 1 do
        if owner == fleet[i].owner and star[dst].x == fleet[i].x2 and star[dst].y == fleet[i].y2 then
            return true
         end
    end
    return false
end